#include <stdio.h>
#include <stdlib.h>

void main(argc, argv)
int argc;
char* argv[];
{
  char* inFilename;
  char* outBasename;
  int maxSize;
  char outFilename[32];
  FILE* inFile;
  FILE* outFile;
  int fileNumber;
  char buffer[1024];
  int bufferCount;
  size_t readSize;

  char* outExt = ".spl";
  size_t bufferSize = 1024;

  if (argc < 4)
  {
    printf("USAGE: %s infilename outbasename maxsize(in Kbytes)\n", argv[0]);
    exit(1);
  }


  inFilename = argv[1];
  outBasename = argv[2];
  maxSize = atoi(argv[3]);

  if (maxSize <= 0) 
  {
    printf("Error in maxSize argument: must be greater then 0\n");
    exit(1);
  }

  if ((inFile = fopen(inFilename, "rb")) == NULL)
  {
    printf("Can't open inFilename: %s\n", inFilename);
    exit(1);
  }

  readSize = bufferSize;
  for (fileNumber = 1; readSize == bufferSize; fileNumber++)
  {
    sprintf(outFilename, "%s%d%s", outBasename, fileNumber, outExt);
  
    if ((outFile = fopen(outFilename, "wb")) == NULL)
    {
      printf("Can't open outFilename: %s\n", outFilename);
      exit(1);
    }

    printf("Writing %s\n", outFilename);
 
    bufferCount = 0;
    while (bufferCount < maxSize && readSize == bufferSize)
    {
      readSize = fread(buffer, 1, bufferSize, inFile);
      fwrite(buffer, 1, readSize, outFile);
      bufferCount++;
    }
  }

  fclose(inFile);
  fclose(outFile);
}


